import { ComponentPropsWithoutRef } from 'react';
import { CustomColor } from "../../constants/themes/colors";
import { ImgData, SizeLS } from "../../constants/types/global";
import { IsDisabledPropsType } from "../../constants/types/styled";
export type Variant = 'filled' | 'outlined' | 'text';
export type Corner = 'round' | 'square';
export type ButtonStyle = {
    variant?: Variant;
    size?: SizeLS;
    corner?: Corner;
    customStyle?: {
        color?: CustomColor;
        backgroundColor?: CustomColor;
        borderColor?: CustomColor;
        hoverColor?: CustomColor;
        hoverBackgroundColor?: CustomColor;
        hoverBorderColor?: CustomColor;
        maxWidth?: string;
    };
} & IsDisabledPropsType;
export type ButtonDataProps = {
    icon?: ImgData;
    children: string;
};
export type HTMLButtonProps = Pick<ComponentPropsWithoutRef<'button'>, 'id' | 'name' | 'onClick' | 'type'>;
export type HocButtonData = {
    icon?: ImgData;
    text: string;
} & HTMLButtonProps;
export type ButtonProps = ButtonDataProps & ButtonStyle & HTMLButtonProps;
